#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityDayHuntCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityDayHuntCFG> M_ActivityDayHuntCFG::msSingleton(nullptr);

int M_ActivityDayHuntCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDayHuntCFGData* M_ActivityDayHuntCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityDayHuntCFGData>& M_ActivityDayHuntCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityDayHuntCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityDayHuntCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDayHuntCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* Reward = element->Attribute("Reward");
			std::vector<std::string> vecReward;
			boost::split(vecReward, Reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecReward[i].c_str(), &temp))
				{
					data.mReward.push_back(temp);
				}
			}
		}
		{
			const char* ExpectHighest = element->Attribute("ExpectHighest");
			std::vector<std::string> vecExpectHighest;
			boost::split(vecExpectHighest, ExpectHighest, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExpectHighest.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExpectHighest[i].c_str(), &temp))
				{
					data.mExpectHighest.push_back(temp);
				}
			}
		}
		{
			const char* DisplayItem = element->Attribute("DisplayItem");
			std::vector<std::string> vecDisplayItem;
			boost::split(vecDisplayItem, DisplayItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplayItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplayItem[i].c_str(), &temp))
				{
					data.mDisplayItem.push_back(temp);
				}
			}
		}
		{
			const char* DisplayMumber = element->Attribute("DisplayMumber");
			std::vector<std::string> vecDisplayMumber;
			boost::split(vecDisplayMumber, DisplayMumber, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecDisplayMumber.size(); i++)
			{
				data.mDisplayMumber.push_back(vecDisplayMumber[i]);
			}
		}
		data.mDisplayResetMumber = element->IntAttribute("DisplayResetMumber");
		data.mbagId = element->IntAttribute("bagId");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityDayHuntCFG::Load()
{
	Load("../Config/M_ActivityDayHuntCFG.xml");
}

M_ActivityDayHuntCFG* M_ActivityDayHuntCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDayHuntCFG());
	}
	return msSingleton.get();
}
